//-----------------------------------------
// LScript Item Animation template
//
// Mike Green's quickparent follower Lscript
// copyright 2005 Mike Green
// Dodgy@shortbutpurple.fsnet.co.uk



@version 2.2
@warnings
@script motion
@name MGParentFollower
@save relative



// global values go here
myversion=1.1;

//version 1.1
//Fixed small bug in calculation. 

mytime=0.0;
myscale=<1,1,1>;
myoffset=<0,0,0>;
mysetup=0;
// create: obj      // with the Layout Object Agent argument
create      // without the Layout Object Agent argument
{
    // one-time initialization takes place here
}

destroy
{
    // take care of final clean-up activities here
}

process: ma, frame, time
{
    // called each time the object's transformational values change

    mytemp = ma.objID;
    myobj = getagentbyid(mytemp.id);
    myparent = myobj.parent;
    settime  = time + mytime;
    myrot = myparent.getRotation(settime);
    myoldrot = ma.get(ROTATION,time);

    setdesc("MGParentFollower Time:" + mytime + "Secs Scale:<" + myscale + "> Offset:<" + myoffset +">");

    if(myparent.isBone())
        myparrest= myparent.restParam(ROTATION);
    else
        myparrest= myparent.getRotation(mysetup);

    offset=myoffset + myoldrot;

    mynewrot = <(myrot.x - myparrest.x) * (!myobj.axislocks[4]) * myscale.x + offset.x,
                (myrot.y - myparrest.y) * (!myobj.axislocks[5]) * myscale.y + offset.y,
                (myrot.z - myparrest.z) * (!myobj.axislocks[6]) * myscale.z + offset.z>;

    ma.set(ROTATION,mynewrot);
}

load: what,io
{
    if(what == SCENEMODE)   // processing an ASCII scene file
    {
        mytime = io.read().asNum();
        mysetup = io.read().asNum();
        myscale = io.read().asVec();
        myoffset = io.read().asVec();
    }
}

save: what,io
{
    if(what == SCENEMODE)
    {
        io.writeln(mytime);
        io.writeln(mysetup);
        io.writeln(myscale);
        io.writeln(myoffset);
    }
}

options
{
    reqbegin("ParentFollower Ver:"+myversion);

    c1 = ctlnumber("Time Offset",mytime);
    c2 = ctlnumber("Setup Time",mysetup);
    v1 = ctlvector("Scale",myscale);
    v2 = ctlvector("Offset",myoffset);

    if (!reqpost()) return;

    mytime=getvalue(c1);
    mysetup=getvalue(c2);
    myscale=getvalue(v1);
    myoffset=getvalue(v2);

    reqend();

}

getagentbyid:id
{
//debug();
    item=Mesh();
    while(item)
    {
        if (item.id==id)
            return item;
        tempbone=item.bone();
        while(tempbone)
        {
            if(tempbone.id==id)
                return tempbone;
            tempbone=tempbone.next();
        }
        item=item.next();
    }

    item=Light();
    while(item)
    {
        if (item.id==id)
            return item;
        item=item.next();
    }

    item=Camera();
    while(item)
    {
        if (item.id==id)
            return item;
        item=item.next();
    }
    return (nil);
}
